#ifndef LIB_SKYMAP_H
#define LIB_SKYMAP_H

#include "math/vec.h"
#include "base/view.h"
#include "base/texture.h"

typedef enum {
	SKYMAP_USE_NONE,
	SKYMAP_USE_2D,
	SKYMAP_USE_CUBEMAP,
} skymapState_t;

class Skymap {
protected:

	Texture skyTexCubemap;
	Texture skyTexBackup[6];	//in case cube mapping isnt supported

	skymapState_t state;

	void reset();
	void drawSky();

public:
	Skymap() {reset();}
	~Skymap() {shutdown();}

	bool init() { return true; } //does nothing yet - there for consistency.
	void shutdown();

	void render(const View *view);
	skymapState_t setSkyTex(const char *skyfn[6]);
	
	skymapState_t getState() { return state; }

	const Texture *getSkyTexCubemap() const { return &skyTexCubemap; }
};

//bool Init_Skymap();
//void Update_Skymap();
//void Shutdown_Skymap();
//void Skymap_SetSkyTex(const char *skyfn[6]);

#endif //LIB_SKYMAP_H
